<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMoeda ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMoeda
 * @subpackage Arrays
 */
class ArrayOfMoeda extends AbstractStructArrayBase
{
    /**
     * The Moeda
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\Moeda[]
     */
    public $Moeda;
    /**
     * Constructor method for ArrayOfMoeda
     * @uses ArrayOfMoeda::setMoeda()
     * @param \LGRAVE\StructType\Moeda[] $moeda
     */
    public function __construct(array $moeda = array())
    {
        $this
            ->setMoeda($moeda);
    }
    /**
     * Get Moeda value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\Moeda[]|null
     */
    public function getMoeda()
    {
        return isset($this->Moeda) ? $this->Moeda : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMoeda method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMoeda method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMoedaForArrayConstraintsFromSetMoeda(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMoedaMoedaItem) {
            // validation for constraint: itemType
            if (!$arrayOfMoedaMoedaItem instanceof \LGRAVE\StructType\Moeda) {
                $invalidValues[] = is_object($arrayOfMoedaMoedaItem) ? get_class($arrayOfMoedaMoedaItem) : sprintf('%s(%s)', gettype($arrayOfMoedaMoedaItem), var_export($arrayOfMoedaMoedaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Moeda property can only contain items of type \LGRAVE\StructType\Moeda, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Moeda value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\Moeda[] $moeda
     * @return \LGRAVE\ArrayType\ArrayOfMoeda
     */
    public function setMoeda(array $moeda = array())
    {
        // validation for constraint: array
        if ('' !== ($moedaArrayErrorMessage = self::validateMoedaForArrayConstraintsFromSetMoeda($moeda))) {
            throw new \InvalidArgumentException($moedaArrayErrorMessage, __LINE__);
        }
        if (is_null($moeda) || (is_array($moeda) && empty($moeda))) {
            unset($this->Moeda);
        } else {
            $this->Moeda = $moeda;
        }
        return $this;
    }
    /**
     * Add item to Moeda value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\Moeda $item
     * @return \LGRAVE\ArrayType\ArrayOfMoeda
     */
    public function addToMoeda(\LGRAVE\StructType\Moeda $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\Moeda) {
            throw new \InvalidArgumentException(sprintf('The Moeda property can only contain items of type \LGRAVE\StructType\Moeda, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Moeda[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\Moeda|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\Moeda|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\Moeda|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\Moeda|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\Moeda|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Moeda
     */
    public function getAttributeName()
    {
        return 'Moeda';
    }
}
