<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPUDOExtensionOutput ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPUDOExtensionOutput
 * @subpackage Arrays
 */
class ArrayOfPUDOExtensionOutput extends AbstractStructArrayBase
{
    /**
     * The PUDOExtensionOutput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\PUDOExtensionOutput[]
     */
    public $PUDOExtensionOutput;
    /**
     * Constructor method for ArrayOfPUDOExtensionOutput
     * @uses ArrayOfPUDOExtensionOutput::setPUDOExtensionOutput()
     * @param \LGRAVE\StructType\PUDOExtensionOutput[] $pUDOExtensionOutput
     */
    public function __construct(array $pUDOExtensionOutput = array())
    {
        $this
            ->setPUDOExtensionOutput($pUDOExtensionOutput);
    }
    /**
     * Get PUDOExtensionOutput value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\PUDOExtensionOutput[]|null
     */
    public function getPUDOExtensionOutput()
    {
        return isset($this->PUDOExtensionOutput) ? $this->PUDOExtensionOutput : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPUDOExtensionOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPUDOExtensionOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePUDOExtensionOutputForArrayConstraintsFromSetPUDOExtensionOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPUDOExtensionOutputPUDOExtensionOutputItem) {
            // validation for constraint: itemType
            if (!$arrayOfPUDOExtensionOutputPUDOExtensionOutputItem instanceof \LGRAVE\StructType\PUDOExtensionOutput) {
                $invalidValues[] = is_object($arrayOfPUDOExtensionOutputPUDOExtensionOutputItem) ? get_class($arrayOfPUDOExtensionOutputPUDOExtensionOutputItem) : sprintf('%s(%s)', gettype($arrayOfPUDOExtensionOutputPUDOExtensionOutputItem), var_export($arrayOfPUDOExtensionOutputPUDOExtensionOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PUDOExtensionOutput property can only contain items of type \LGRAVE\StructType\PUDOExtensionOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PUDOExtensionOutput value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\PUDOExtensionOutput[] $pUDOExtensionOutput
     * @return \LGRAVE\ArrayType\ArrayOfPUDOExtensionOutput
     */
    public function setPUDOExtensionOutput(array $pUDOExtensionOutput = array())
    {
        // validation for constraint: array
        if ('' !== ($pUDOExtensionOutputArrayErrorMessage = self::validatePUDOExtensionOutputForArrayConstraintsFromSetPUDOExtensionOutput($pUDOExtensionOutput))) {
            throw new \InvalidArgumentException($pUDOExtensionOutputArrayErrorMessage, __LINE__);
        }
        if (is_null($pUDOExtensionOutput) || (is_array($pUDOExtensionOutput) && empty($pUDOExtensionOutput))) {
            unset($this->PUDOExtensionOutput);
        } else {
            $this->PUDOExtensionOutput = $pUDOExtensionOutput;
        }
        return $this;
    }
    /**
     * Add item to PUDOExtensionOutput value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\PUDOExtensionOutput $item
     * @return \LGRAVE\ArrayType\ArrayOfPUDOExtensionOutput
     */
    public function addToPUDOExtensionOutput(\LGRAVE\StructType\PUDOExtensionOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\PUDOExtensionOutput) {
            throw new \InvalidArgumentException(sprintf('The PUDOExtensionOutput property can only contain items of type \LGRAVE\StructType\PUDOExtensionOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PUDOExtensionOutput[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\PUDOExtensionOutput|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\PUDOExtensionOutput|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\PUDOExtensionOutput|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\PUDOExtensionOutput|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\PUDOExtensionOutput|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PUDOExtensionOutput
     */
    public function getAttributeName()
    {
        return 'PUDOExtensionOutput';
    }
}
