<?php

namespace LGRAVE\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPUDOOutput ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPUDOOutput
 * @subpackage Arrays
 */
class ArrayOfPUDOOutput extends AbstractStructArrayBase
{
    /**
     * The PUDOOutput
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LGRAVE\StructType\PUDOOutput[]
     */
    public $PUDOOutput;
    /**
     * Constructor method for ArrayOfPUDOOutput
     * @uses ArrayOfPUDOOutput::setPUDOOutput()
     * @param \LGRAVE\StructType\PUDOOutput[] $pUDOOutput
     */
    public function __construct(array $pUDOOutput = array())
    {
        $this
            ->setPUDOOutput($pUDOOutput);
    }
    /**
     * Get PUDOOutput value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LGRAVE\StructType\PUDOOutput[]|null
     */
    public function getPUDOOutput()
    {
        return isset($this->PUDOOutput) ? $this->PUDOOutput : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPUDOOutput method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPUDOOutput method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePUDOOutputForArrayConstraintsFromSetPUDOOutput(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPUDOOutputPUDOOutputItem) {
            // validation for constraint: itemType
            if (!$arrayOfPUDOOutputPUDOOutputItem instanceof \LGRAVE\StructType\PUDOOutput) {
                $invalidValues[] = is_object($arrayOfPUDOOutputPUDOOutputItem) ? get_class($arrayOfPUDOOutputPUDOOutputItem) : sprintf('%s(%s)', gettype($arrayOfPUDOOutputPUDOOutputItem), var_export($arrayOfPUDOOutputPUDOOutputItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PUDOOutput property can only contain items of type \LGRAVE\StructType\PUDOOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PUDOOutput value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\PUDOOutput[] $pUDOOutput
     * @return \LGRAVE\ArrayType\ArrayOfPUDOOutput
     */
    public function setPUDOOutput(array $pUDOOutput = array())
    {
        // validation for constraint: array
        if ('' !== ($pUDOOutputArrayErrorMessage = self::validatePUDOOutputForArrayConstraintsFromSetPUDOOutput($pUDOOutput))) {
            throw new \InvalidArgumentException($pUDOOutputArrayErrorMessage, __LINE__);
        }
        if (is_null($pUDOOutput) || (is_array($pUDOOutput) && empty($pUDOOutput))) {
            unset($this->PUDOOutput);
        } else {
            $this->PUDOOutput = $pUDOOutput;
        }
        return $this;
    }
    /**
     * Add item to PUDOOutput value
     * @throws \InvalidArgumentException
     * @param \LGRAVE\StructType\PUDOOutput $item
     * @return \LGRAVE\ArrayType\ArrayOfPUDOOutput
     */
    public function addToPUDOOutput(\LGRAVE\StructType\PUDOOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LGRAVE\StructType\PUDOOutput) {
            throw new \InvalidArgumentException(sprintf('The PUDOOutput property can only contain items of type \LGRAVE\StructType\PUDOOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PUDOOutput[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LGRAVE\StructType\PUDOOutput|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LGRAVE\StructType\PUDOOutput|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LGRAVE\StructType\PUDOOutput|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LGRAVE\StructType\PUDOOutput|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LGRAVE\StructType\PUDOOutput|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PUDOOutput
     */
    public function getAttributeName()
    {
        return 'PUDOOutput';
    }
}
