<?php

namespace LGRAVE\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PudoInternacionalInput StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PudoInternacionalInput
 * @subpackage Structs
 */
class PudoInternacionalInput extends AbstractStructBase
{
    /**
     * The City
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $City;
    /**
     * The CountryCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryCode;
    /**
     * The DefineNrResults
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $DefineNrResults;
    /**
     * The LanguageCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LanguageCode;
    /**
     * The NrMaxResults
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NrMaxResults;
    /**
     * The OperatorCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OperatorCode;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Password;
    /**
     * The PostalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PostalCode;
    /**
     * The UserName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserName;
    /**
     * Constructor method for PudoInternacionalInput
     * @uses PudoInternacionalInput::setCity()
     * @uses PudoInternacionalInput::setCountryCode()
     * @uses PudoInternacionalInput::setDefineNrResults()
     * @uses PudoInternacionalInput::setLanguageCode()
     * @uses PudoInternacionalInput::setNrMaxResults()
     * @uses PudoInternacionalInput::setOperatorCode()
     * @uses PudoInternacionalInput::setPassword()
     * @uses PudoInternacionalInput::setPostalCode()
     * @uses PudoInternacionalInput::setUserName()
     * @param string $city
     * @param string $countryCode
     * @param bool $defineNrResults
     * @param string $languageCode
     * @param string $nrMaxResults
     * @param string $operatorCode
     * @param string $password
     * @param string $postalCode
     * @param string $userName
     */
    public function __construct($city = null, $countryCode = null, $defineNrResults = null, $languageCode = null, $nrMaxResults = null, $operatorCode = null, $password = null, $postalCode = null, $userName = null)
    {
        $this
            ->setCity($city)
            ->setCountryCode($countryCode)
            ->setDefineNrResults($defineNrResults)
            ->setLanguageCode($languageCode)
            ->setNrMaxResults($nrMaxResults)
            ->setOperatorCode($operatorCode)
            ->setPassword($password)
            ->setPostalCode($postalCode)
            ->setUserName($userName);
    }
    /**
     * Get City value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCity()
    {
        return isset($this->City) ? $this->City : null;
    }
    /**
     * Set City value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $city
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        if (is_null($city) || (is_array($city) && empty($city))) {
            unset($this->City);
        } else {
            $this->City = $city;
        }
        return $this;
    }
    /**
     * Get CountryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryCode()
    {
        return isset($this->CountryCode) ? $this->CountryCode : null;
    }
    /**
     * Set CountryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryCode
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        if (is_null($countryCode) || (is_array($countryCode) && empty($countryCode))) {
            unset($this->CountryCode);
        } else {
            $this->CountryCode = $countryCode;
        }
        return $this;
    }
    /**
     * Get DefineNrResults value
     * @return bool|null
     */
    public function getDefineNrResults()
    {
        return $this->DefineNrResults;
    }
    /**
     * Set DefineNrResults value
     * @param bool $defineNrResults
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setDefineNrResults($defineNrResults = null)
    {
        // validation for constraint: boolean
        if (!is_null($defineNrResults) && !is_bool($defineNrResults)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($defineNrResults, true), gettype($defineNrResults)), __LINE__);
        }
        $this->DefineNrResults = $defineNrResults;
        return $this;
    }
    /**
     * Get LanguageCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLanguageCode()
    {
        return isset($this->LanguageCode) ? $this->LanguageCode : null;
    }
    /**
     * Set LanguageCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $languageCode
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setLanguageCode($languageCode = null)
    {
        // validation for constraint: string
        if (!is_null($languageCode) && !is_string($languageCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($languageCode, true), gettype($languageCode)), __LINE__);
        }
        if (is_null($languageCode) || (is_array($languageCode) && empty($languageCode))) {
            unset($this->LanguageCode);
        } else {
            $this->LanguageCode = $languageCode;
        }
        return $this;
    }
    /**
     * Get NrMaxResults value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNrMaxResults()
    {
        return isset($this->NrMaxResults) ? $this->NrMaxResults : null;
    }
    /**
     * Set NrMaxResults value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nrMaxResults
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setNrMaxResults($nrMaxResults = null)
    {
        // validation for constraint: string
        if (!is_null($nrMaxResults) && !is_string($nrMaxResults)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nrMaxResults, true), gettype($nrMaxResults)), __LINE__);
        }
        if (is_null($nrMaxResults) || (is_array($nrMaxResults) && empty($nrMaxResults))) {
            unset($this->NrMaxResults);
        } else {
            $this->NrMaxResults = $nrMaxResults;
        }
        return $this;
    }
    /**
     * Get OperatorCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOperatorCode()
    {
        return isset($this->OperatorCode) ? $this->OperatorCode : null;
    }
    /**
     * Set OperatorCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $operatorCode
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setOperatorCode($operatorCode = null)
    {
        // validation for constraint: string
        if (!is_null($operatorCode) && !is_string($operatorCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operatorCode, true), gettype($operatorCode)), __LINE__);
        }
        if (is_null($operatorCode) || (is_array($operatorCode) && empty($operatorCode))) {
            unset($this->OperatorCode);
        } else {
            $this->OperatorCode = $operatorCode;
        }
        return $this;
    }
    /**
     * Get Password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->Password) ? $this->Password : null;
    }
    /**
     * Set Password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->Password);
        } else {
            $this->Password = $password;
        }
        return $this;
    }
    /**
     * Get PostalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPostalCode()
    {
        return isset($this->PostalCode) ? $this->PostalCode : null;
    }
    /**
     * Set PostalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $postalCode
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setPostalCode($postalCode = null)
    {
        // validation for constraint: string
        if (!is_null($postalCode) && !is_string($postalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postalCode, true), gettype($postalCode)), __LINE__);
        }
        if (is_null($postalCode) || (is_array($postalCode) && empty($postalCode))) {
            unset($this->PostalCode);
        } else {
            $this->PostalCode = $postalCode;
        }
        return $this;
    }
    /**
     * Get UserName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserName()
    {
        return isset($this->UserName) ? $this->UserName : null;
    }
    /**
     * Set UserName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userName
     * @return \LGRAVE\StructType\PudoInternacionalInput
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        if (is_null($userName) || (is_array($userName) && empty($userName))) {
            unset($this->UserName);
        } else {
            $this->UserName = $userName;
        }
        return $this;
    }
}
